






      subroutine pdattx( endn,   na,     nn,     root,   strn,   teta,
     +                   x,      y )
c     ------------------------------------------------------------------
c     pdattx: This subroutine computes the product y=a*(1/teta)*a'x.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             na    : number of arcs.
c             nn    : number of nodes.
c             root  : sets beginning of structure.
c     ------------------------------------------------------------------
      integer na    , nn    , root

c     ------------------------------------------------------------------
c     Integer input/output arrays:
c
c             endn(1:na): pointer of network data structure.
c             strn(1:na): adjacency list of network data structure.
c     ------------------------------------------------------------------
      integer
     +        endn(1:na),
     +        strn(1:na)

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c            teta(1:na): normal equations diagonal matrix.
c            x   (1:nn): primal iterate x.
c            y   (1:nn): primal iterate y.
c     ------------------------------------------------------------------
      double precision
     +                 teta(1:na),
     +                 x   (1:nn),
     +                 y   (1:nn)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             arc   : current arc.
c             enod  : current element on endn.
c             snod  : current element on strn.
c     ------------------------------------------------------------------
      integer arc   , enod  , snod

c     ------------------------------------------------------------------
c     Double precision variables:
c
c             aux1  : auxiliary variable.
c     ------------------------------------------------------------------
      double precision aux1

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
      call pdivec ( 0.0d0, nn, y)
      do 20 arc=1,na
         snod = strn(arc)
         enod = endn(arc)
         aux1 = (x(enod)-x(snod))/teta(arc)
         y(snod) = y(snod)-aux1
         y(enod) = y(enod)+aux1
 20   continue
      y(root) = 0d0

c     ------------------------------------------------------------------
c     End of subroutine pdattx.
c     ------------------------------------------------------------------
      end
