







      subroutine pdchkp(endn, ierror, maxa, maxn, maxwkd, na, nn, nwkd, 
     +                  prttyp)
c     ------------------------------------------------------------------
c     pdchkp: This subroutine checks validity of parameters.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             ierror: flags errors in input.
c             maxa  : maximum number of arcs.
c             maxn  : maximum number of nodes.
c             maxwkd: size of pointer array.
c             na    : number of arcs.
c             nn    : number of nodes.
c             nwkd  : amount of temporary storage required.
c             prttyp: printing level.
c     ------------------------------------------------------------------
      integer ierror, maxa  , maxn  , maxwkd,
     +        na    , nn    , nwkd, prttyp
c     ------------------------------------------------------------------
c     Integer input/output arrays:
c
c             endn  (1:  na): pointer of network data structure.
c     ------------------------------------------------------------------
      integer endn  (1:  na)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             ipos  : position within the vector.
c     ------------------------------------------------------------------
      integer ipos

c     ------------------------------------------------------------------
c     Start of executable portion of subroutine.
c
c     Set error condition for no error.
c     ------------------------------------------------------------------
      ierror = 0

c     ------------------------------------------------------------------
c     Check if number of nodes and number of arcs are legal.
c     ------------------------------------------------------------------
      if (na .gt. maxa) ierror = 1
      if (nn .gt. maxn) ierror = 2
      if (ierror .ne. 0) return

c     ------------------------------------------------------------------
c     Check if the number of each node does not exceed the number of
c     nodes.
c     ------------------------------------------------------------------
      ipos = 1
 10   if (ipos .le. na) then
         if (endn(ipos) .gt. nn) then
            ierror = 3
            return
         endif
         ipos = ipos + 1
         goto 10
      endif

c     ------------------------------------------------------------------
c     Check if pointer vector is big enough.
c     ------------------------------------------------------------------
      if (nwkd .gt. maxwkd) ierror = 4

c     ------------------------------------------------------------------
c     Check if output level was correctly set.
c     ------------------------------------------------------------------
      if (prttyp .lt. 0 .or. prttyp .gt. 3) then
         ierror = 5
      endif

c     ------------------------------------------------------------------
c     End of subroutine pdchkp.
c     ------------------------------------------------------------------
      end
