






      subroutine pdivec( const,  dim,    x )
c     ------------------------------------------------------------------
c     pdivec: This subroutine performs the operation x = const. It is
c             based on dcopy dblas routine.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             dim   : order of the vector.
c     ------------------------------------------------------------------
      integer dim

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c             x(1:dim): vector to get the copy.
c     ------------------------------------------------------------------
      double precision x(1:dim)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             i     : loop counter.
c             m     : size of unrolled loop.
c             mp1   : m+1.
c     ------------------------------------------------------------------
      integer i     , m     , mp1

c     ------------------------------------------------------------------
c     Double precision input/output variables:
c
c             const : value to be copied to x.
c     ------------------------------------------------------------------
      double precision const

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
 10   m = mod(dim,4)
      if( m .eq. 0 ) go to 30
      do 20 i = 1,m
         x(i) = const
 20   continue
      if( dim .lt. 4 ) return
 30   mp1 = m + 1
      do 40 i = mp1,dim,4
         x(i) = const
         x(i + 1) = const
         x(i + 2) = const
         x(i + 3) = const
 40   continue

c     ------------------------------------------------------------------
c     End of subroutine pdivec.
c     ------------------------------------------------------------------
      end
