






      subroutine pdlink( nn,     root,   nsoon,  pred,   first,  llink,
     +                   rlink,  rank )
c     ------------------------------------------------------------------
c     pdlink: This subroutine links two subtrees in a Fiboncci heap by
c             updating the arrays pred, rank, llink, rlink  and first.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             nn    : number of nodes.
c             nsoon : son of node.
c             root  : root node.
c     ------------------------------------------------------------------
      integer nn    , nsoon , root

c     ------------------------------------------------------------------
c     Integer input/output arrays:
c
c             first (1:nn): first node.
c             llink (0:nn): part of the node left linked list.
c             pred  (1:nn): list of predecessors.
c             rank  (1:nn): rank of nodes.
c             rlink (0:nn): part of the node right linked list.
c     ------------------------------------------------------------------
      integer first (1:nn), llink (0:nn), pred  (1:nn),
     +        rank  (1:nn), rlink (0:nn)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             osoon : auxiliary variable.
c     ------------------------------------------------------------------
      integer osoon

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
      osoon = first(root)
      rlink(nsoon) = osoon
      llink(osoon) = nsoon
      pred(nsoon) = root
      rank(root) = rank(root) + 1
      first(root) = nsoon

c     ------------------------------------------------------------------
c     End of subroutine pdlink.
c     ------------------------------------------------------------------
      end
