






      subroutine pdpryx( alfa,   dim,    root,   x,      y )
c     ------------------------------------------------------------------
c     pdpryx: This subroutine computes the scalar product alfa=x'y.
c             The vectors x and y have both dimension dim.  This 
c             subroutine is based on the dblas ddot routine.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             dim   : dimension of vectors.
c             root  : beginning of data structure.
c     ------------------------------------------------------------------
      integer dim   , root

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c             x(1:dim): vector x.
c             y(1:dim): vector y.
c     ------------------------------------------------------------------
      double precision
     +        x(1:dim),
     +        y(1:dim)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             i     : loop counter.
c             m     : size of unrolled loop.
c             mp1   : m+1.
c     ------------------------------------------------------------------
      integer i     , m     , mp1

c     ------------------------------------------------------------------
c     Double precision variables:
c
c             alfa  : inner product.
c             dtemp : temporary variable.
c     ------------------------------------------------------------------
      double precision alfa  , dtemp

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
      dtemp = 0d0
      alfa  = 0d0
      x(root) = 0d0
      y(root) = 0d0
 10   m = mod(dim,5)
      if( m .eq. 0 ) go to 30
      do 20 i = 1,m
         dtemp = dtemp + x(i)*y(i)
 20   continue
      if( dim .lt. 5 ) go to 50
 30   mp1 = m + 1
      do 40 i = mp1,dim,5
         dtemp = dtemp + x(i)*y(i) + x(i + 1)*y(i + 1) +
     *        x(i + 2)*y(i + 2) + x(i + 3)*y(i + 3) + x(i + 4)*y(i + 4)
 40   continue
 50   alfa = dtemp

c     ------------------------------------------------------------------
c     End of subroutine pdpryx.
c     ------------------------------------------------------------------
      end
