







      subroutine pdresd( alfa,   dim,    z )
c     ------------------------------------------------------------------
c     pdresd: This subroutine computes the l1 norm of z. The vector z
c             has dimension dim.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             dim: dimension of vector.
c     ------------------------------------------------------------------
      integer dim

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c             z(1:dim): vector whose norm is to be computed.
c     ------------------------------------------------------------------
      double precision z(1:dim)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             i     : loop counter.
c             m     : size of unrolled loop.
c             mp1   : m+1.
c     ------------------------------------------------------------------
      integer i     , m     , mp1

c     ------------------------------------------------------------------
c     Double precision input/output variables:
c
c             alfa  : l-1 norm of vector.
c     ------------------------------------------------------------------
      double precision alfa

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
      alfa = 0d0
 10   m = mod(dim,4)
      if( m .eq. 0 ) go to 30
      do 20 i = 1,m
         alfa = alfa+dabs(z(i))
 20   continue
      if( dim .lt. 4 ) return
 30   mp1 = m + 1
      do 40 i = mp1,dim,4
         alfa=alfa+dabs(z(i))+dabs(z(i+1))+dabs(z(i+2))+dabs(z(i+3))
 40   continue

c     ------------------------------------------------------------------
c     End of subroutine pdresd.
c     ------------------------------------------------------------------
      end
