







      subroutine pdsplt( father, first,  llink,  lost,   nn,     pred,
     +                   rank,   rlink,  soon )
c     ------------------------------------------------------------------
c     pdsplt: This subroutine splits a tree into two subtrees in a
c             Fibonacci heap by updating the arrays pred, rank, llink,
c             rlink, first and lost.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             father: father of node.
c             nn    : number of nodes.
c             soon  : son of node.
c     ------------------------------------------------------------------
      integer father, nn    , soon

c     ------------------------------------------------------------------
c     Integer input/output arrays:
c
c             first (1:nn): first node.
c             llink (0:nn): part of the node left linked list.
c             lost  (1:nn): number of lost nodes per node.
c             pred  (1:nn): list of predecessors.
c             rank  (1:nn): rank of nodes.
c             rlink (0:nn): part of the node right linked list.
c     ------------------------------------------------------------------
      integer first (1:nn), llink (0:nn), lost  (1:nn), pred  (1:nn),
     +        rank  (1:nn), rlink (0:nn)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             lsoon : left son.
c             rsoon : right son.
c     ------------------------------------------------------------------
      integer lsoon , rsoon

c     ------------------------------------------------------------------
c     Start of executable portion of subroutine.
c     ------------------------------------------------------------------
      lsoon = llink(soon)
      rsoon = rlink(soon)
      rlink(soon) = 0
      llink(soon) = 0
      rlink(lsoon) = rsoon
      llink(rsoon) = lsoon
      pred(soon) = 0
      rank(father) = rank(father)-1
      if (lsoon.eq.0) first(father)=rsoon
      lost(soon) = 0
      if (pred(father).ne.0) lost(father)=lost(father)+1

c     ------------------------------------------------------------------
c     End of subroutine pdsplt.
c     ------------------------------------------------------------------
      end
