






      subroutine pdsteq( dim,    root,   x,      y )
c     ------------------------------------------------------------------
c     pdsteq: This subroutine performs the operation x = y.  The vectors 
c             x and y have both dimension dim.  This subroutine is based 
c             on dcopy dblas routine.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             dim   : dimension of vectors.
c             root  : beginning of data structure.
c     ------------------------------------------------------------------
      integer dim   , root

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c             x(1:dim): vector x.
c             y(1:dim): vector y.
c     ------------------------------------------------------------------
      double precision
     +     x(1:dim),
     +     y(1:dim)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             i     : loop counter.
c             m     : size of unrolled loop.
c             mp1   : m + 1.
c     ------------------------------------------------------------------
      integer i     , m     , mp1

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
 10   m = mod(dim,7)
      if( m .eq. 0 ) go to 30
      do 20 i = 1,m
         x(i) = y(i)
 20   continue
      if( dim .lt. 7 ) return
 30   mp1 = m + 1
      do 40 i = mp1,dim,7
         x(i) = y(i)
         x(i + 1) = y(i + 1)
         x(i + 2) = y(i + 2)
         x(i + 3) = y(i + 3)
         x(i + 4) = y(i + 4)
         x(i + 5) = y(i + 5)
         x(i + 6) = y(i + 6)
 40   continue
      x(root) = 0d0

c     ------------------------------------------------------------------
c     End of subroutine pdsteq.
c     ------------------------------------------------------------------
      end
