






      subroutine pdupv1( alfa,   dim,    root,   x,      y )
c     ------------------------------------------------------------------
c     pdupv1: This subroutine updates the vector x by using the formula
c             x = x + alfa*y, where y is a scalar. The vectors x and y
c             have both dimension dim. This subroutine is based on the
c             dblas daxpy routine.
c     ------------------------------------------------------------------
      implicit none

c     ------------------------------------------------------------------
c     Integer input/output variables:
c
c             dim   : dimension of vectors x and y
c             root  : sets beginning of structure.
c     ------------------------------------------------------------------
      integer dim   , root

c     ------------------------------------------------------------------
c     Double precision input/output arrays:
c
c             x(1:dim): vector x.
c             y(1:dim): vector y, which will accomodate the result.
c     ------------------------------------------------------------------
      double precision
     +                 x(1:dim),
     +                 y(1:dim)

c     ------------------------------------------------------------------
c     Integer variables:
c
c             i     : loop counter.
c             m     : size of unrolled loop.
c             mp1   : m+1.
c     ------------------------------------------------------------------
      integer i     , m     , mp1

c     ------------------------------------------------------------------
c     Double precision input/output variables:
c
c             alfa  : factor of y.
c     ------------------------------------------------------------------
      double precision alfa

c     ------------------------------------------------------------------
c     Start of executable section of subroutine.
c     ------------------------------------------------------------------
 10   m = mod(dim,4)
      if( m .eq. 0 ) go to 30
      do 20 i = 1,m
         x(i) = x(i) + alfa*y(i)
 20   continue
      if( dim .lt. 4 ) return
 30   mp1 = m + 1
      do 40 i = mp1,dim,4
         x(i) = x(i) + alfa*y(i)
         x(i + 1) = x(i + 1) + alfa*y(i + 1)
         x(i + 2) = x(i + 2) + alfa*y(i + 2)
         x(i + 3) = x(i + 3) + alfa*y(i + 3)
 40   continue
      x(root) = 0d0

c     ------------------------------------------------------------------
c     End of subroutine pdupv1.
c     ------------------------------------------------------------------
      end
